import { configure } from 'mobx';
export { makeAutoObservable, makeObservable } from 'mobx';
import { getGlobalState } from './lib/context/global-state.mjs';
export { FlowRdfCoreGlobals, isolateGlobalState } from './lib/context/global-state.mjs';
export { ContextRegistry } from './lib/context/context-registry.mjs';
export { DEFAULT_CONTEXT_ID, FlowContext } from './lib/context/flow-context.mjs';
export { MapRegistry } from './lib/context/map-registry.mjs';
export { QueryRegistry } from './lib/context/query-registry.mjs';
export { ReactiveExpression } from './lib/expressions/reactive-expression.mjs';
export { MapDataSource } from './lib/map-style/map-data-source.mjs';
export { BackgroundLayerStyleBuilder, CircleLayerStyleBuilder, FillExtrusionLayerStyleBuilder, FillLayerStyleBuilder, HeatmapLayerStyleBuilder, HillshadeLayerStyleBuilder, LineLayerStyleBuilder, RasterLayerStyleBuilder, SymbolLayerStyleBuilder, layerStyle } from './lib/map-style/map-layer-style-builder-generated.mjs';
export { MapLayerStyleBuilder, StyleExpression, expr } from './lib/map-style/map-layer-style-builder.mjs';
export { MapLayer } from './lib/map-style/map-layer.mjs';
export { MapStyle } from './lib/map-style/map-style.mjs';
export { FlowCoreMap } from './lib/map/flow-core-map.mjs';
export { MapPopup } from './lib/map/support/map-popup.mjs';
export { Query, query, queryMany, queryOne } from './lib/queries/query.mjs';
export { action, computed, observable, serialize } from './lib/state-store/decorators.mjs';
export { traceReaction } from './lib/state-store/utils.mjs';
export { StateStore } from './lib/state-store/state-store.mjs';

configure({ isolateGlobalState: false, useProxies: "always" });
const globalContextRegistry = getGlobalState().globalContextRegistry;
const initializeContext = globalContextRegistry.initializeContext.bind(globalContextRegistry);
const uninitializeContext = globalContextRegistry.uninitializeContext.bind(globalContextRegistry);
const getContext = globalContextRegistry.getContext.bind(globalContextRegistry);

export { getContext, getGlobalState, initializeContext, uninitializeContext };
