import announce from '../utils/announce.mjs';
import { getGlobal } from '../utils/global.mjs';
import { ContextRegistry } from './context-registry.mjs';
import { configure } from 'mobx';

var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
class FlowRdfCoreGlobals {
  constructor() {
    /**
     * FlowRdfCoreGlobals version.
     * Compatiblity with other versions loaded in memory as long as this version matches.
     * It indicates that the global state still stores similar information
     *
     * N.B: this version is unrelated to the package version.
     */
    __publicField(this, "version", 1);
    __publicField(this, "globalContextRegistry", new ContextRegistry());
  }
}
let canMergeGlobalState = true;
let isolateCalled = false;
let globalState = function() {
  const global = getGlobal();
  if (global.__flowRdfCoreInstanceCount > 0 && !global.__flowRdfCoreGlobals) {
    canMergeGlobalState = false;
  }
  if (global.__flowRdfCoreGlobals && global.__flowRdfCoreGlobals.version !== new FlowRdfCoreGlobals().version) {
    canMergeGlobalState = false;
  }
  if (!canMergeGlobalState) {
    setTimeout(() => {
      if (!isolateCalled) {
        throw new Error(
          'There are multiple, different versions of FlowRdfCore active. Make sure FlowRdfCore is loaded only once or use `configure({ isolateGlobalState: true })`",'
        );
      }
    }, 1);
    return new FlowRdfCoreGlobals();
  } else if (global.__flowRdfCoreGlobals) {
    global.__flowRdfCoreInstanceCount += 1;
    return global.__flowRdfCoreGlobals;
  } else {
    global.__flowRdfCoreInstanceCount = 1;
    configure({
      enforceActions: "never"
    });
    announce();
    return global.__flowRdfCoreGlobals = new FlowRdfCoreGlobals();
  }
}();
function isolateGlobalState() {
  isolateCalled = true;
  if (canMergeGlobalState) {
    const global = getGlobal();
    if (--global.__flowRdfCoreInstanceCount === 0) {
      global.__flowRdfCoreGlobals = void 0;
    }
    globalState = new FlowRdfCoreGlobals();
  }
}
function getGlobalState() {
  return globalState;
}

export { FlowRdfCoreGlobals, getGlobalState, isolateGlobalState };
