import P from 'parsimmon';

function PREFIX(operatorsParser, nextParser) {
  const parser = P.lazy(() => {
    return P.seq(operatorsParser, parser).or(nextParser);
  });
  return parser;
}
function BINARY_RIGHT(operatorsParser, nextParser) {
  const parser = P.lazy(() => nextParser.chain((next) => P.seq(operatorsParser, P.of(next), parser).or(P.of(next))));
  return parser;
}
function TERNARY_RIGHT(operatorsParser, nextParser) {
  const parser = P.lazy(
    () => nextParser.chain(
      (next) => P.seqMap(
        operatorsParser,
        P.of(next),
        parser,
        P.string(":").trim(P.optWhitespace),
        parser,
        (op, cond, val1, _colon, val2) => [op, ["to-boolean", cond], val1, val2]
      ).or(P.of(next))
    )
  );
  return parser;
}
function BINARY_LEFT(operatorsParser, nextParser) {
  return P.seqMap(nextParser, P.seq(operatorsParser, nextParser).many(), (first, rest) => {
    return rest.reduce((acc, ch) => {
      const [op, another] = ch;
      return [op, acc, another];
    }, first);
  });
}

export { BINARY_LEFT, BINARY_RIGHT, PREFIX, TERNARY_RIGHT };
