var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
class MapEvent {
  constructor(type, map, originalEvent) {
    __publicField(this, "type");
    __publicField(this, "map");
    __publicField(this, "originalEvent");
    this.type = type;
    this.map = map;
    this.originalEvent = originalEvent;
  }
  static fromMaplibreEvent(type, map, maplibreEvent) {
    return new MapEvent(type, map, maplibreEvent.originalEvent);
  }
}
class MapMouseEvent extends MapEvent {
  constructor(type, map, point, lngLat, features, originalEvent) {
    super(type, map, originalEvent);
    /**
     * The pixel coordinates of the mouse cursor, relative to the map and measured from the top left corner.
     */
    __publicField(this, "point");
    /**
     * The geographic location on the map of the mouse cursor.
     */
    __publicField(this, "lngLat");
    __publicField(this, "features");
    this.point = point;
    this.lngLat = lngLat;
    this.features = features;
  }
  static fromMaplibreMouseEvent(type, maplibreMouseEvent, map, features) {
    return new MapMouseEvent(
      type,
      map,
      [maplibreMouseEvent.point.x, maplibreMouseEvent.point.y],
      [maplibreMouseEvent.lngLat.lng, maplibreMouseEvent.lngLat.lat],
      features,
      maplibreMouseEvent.originalEvent
    );
  }
}
class MapSourceEvent extends MapEvent {
  constructor(type, map, source) {
    super(type, map);
    __publicField(this, "source");
    this.source = source;
  }
}
class MapLoadingEvent extends MapEvent {
  constructor(map, loading) {
    super("loading", map);
    __publicField(this, "loading");
    this.loading = loading;
  }
}
class MapStyleChangeEvent extends MapEvent {
  constructor(type, map, oldStyle, newStyle) {
    super(type, map);
    __publicField(this, "oldStyle");
    __publicField(this, "newStyle");
    this.oldStyle = oldStyle;
    this.newStyle = newStyle;
  }
}

export { MapEvent, MapLoadingEvent, MapMouseEvent, MapSourceEvent, MapStyleChangeEvent };
