var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
class AsyncCommitter {
  constructor() {
    __publicField(this, "_requestId", 0);
    __publicField(this, "_commitId", 0);
  }
  async resolve(promise) {
    this._requestId += 1;
    const currentRequestId = this._requestId;
    const value = await promise;
    if (currentRequestId <= this._commitId) {
      return { succeeded: false };
    }
    this._commitId = currentRequestId;
    return { succeeded: true, value };
  }
  async run(asyncFunction) {
    return this.resolve(asyncFunction());
  }
  abandon() {
    this._commitId = this._requestId;
  }
}

export { AsyncCommitter };
