import { getType } from '@turf/invariant';
import { isPlainObject } from './type-checks.mjs';

const isPoint = (val) => {
  if (!isPlainObject(val)) {
    return false;
  }
  return getType(val) === "Point";
};
const isLineString = (val) => {
  if (!isPlainObject(val)) {
    return false;
  }
  return getType(val) === "LineString";
};
const isPolygon = (val) => {
  if (!isPlainObject(val)) {
    return false;
  }
  return getType(val) === "Polygon";
};
const isMultiPolygon = (val) => {
  if (!val) {
    return false;
  }
  return getType(val) === "MultiPolygon";
};

export { isLineString, isMultiPolygon, isPoint, isPolygon };
