import { debounce } from './debounce.mjs';
import { memoize } from './functional.mjs';

function throttle(func, wait, options) {
  if (typeof func != "function") {
    throw new TypeError("Expected a function");
  }
  return debounce(func, wait, { ...options, maxWait: wait });
}
function throttleWithArgs(fn, wait, options) {
  const memoizedThrottleFn = memoize(
    () => debounce(fn, wait, options),
    options
  );
  return (...args) => {
    memoizedThrottleFn(...args)(...args);
  };
}

export { throttle as default, throttle, throttleWithArgs };
