var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet = (obj, member, getter) => {
  __accessCheck(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var __privateSet = (obj, member, value, setter) => {
  __accessCheck(obj, member, "write to private field");
  setter ? setter.call(obj, value) : member.set(obj, value);
  return value;
};
var _value, _settled, _status;
class WatchablePromise extends Promise {
  constructor(executor) {
    super((resolve, reject) => {
      executor(
        (value) => {
          resolve(value);
          __privateSet(this, _value, value);
          __privateSet(this, _settled, true);
          __privateSet(this, _status, "fulfilled");
        },
        (reason) => {
          reject(reason);
          __privateSet(this, _settled, true);
          __privateSet(this, _status, "rejected");
        }
      );
    });
    __privateAdd(this, _value, void 0);
    __privateAdd(this, _settled, false);
    __privateAdd(this, _status, "pending");
  }
  get settled() {
    return __privateGet(this, _settled);
  }
  get status() {
    return __privateGet(this, _status);
  }
  get value() {
    return __privateGet(this, _value);
  }
}
_value = new WeakMap();
_settled = new WeakMap();
_status = new WeakMap();

export { WatchablePromise };
